/**
 * Overlord that sets up a room given only a single spawn with a minimum energy to build one harvester.
 * 
 * Setup is considered finished once 3 spawns have been built and at least one creep is maintaining the RCL
 */

function overlord (name, goal) {  // TODO can I do makeshift inheritance?

    /* Unique identifier, set at creation or by deserialize() */
    this.id = name;

    /* Goal the overlord follows */
    this.goal = goal;

    /* Serializes the overlord state so that it can survive in memory */
    this.serialize = function(memory_key) {};

    /* Reconstructs the overlord state from memory given its identifier */
    this.deserialize =  function(memory_key) {};
};

module.exports = overlord;